/*

 Copyright (c) 2006 Pavel Novak.

 The use and distribution terms for this software are contained in the file named License.txt, 
 which can be found in the root of the NetSim distribution. By using this software 
 in any fashion, you are agreeing to be bound by the terms of this license.
 
 You must not remove this notice from this software.

*/

using System;
using System.IO;

namespace NetSim.Gui
{
	/// <summary>
	/// Represents a "console" in the application which is used to display messages to the user.
	/// </summary>
	public class Console
	{
		public static TextWriter Out
		{
			get { return outWriter; }
			set { outWriter = value; }
		}
		private static TextWriter outWriter;
	
		private Console()
		{
		}

		public static void Write(string s)
		{
			outWriter.Write(s);
		}

		public static void Write(string format, params object[] arg)
		{
			outWriter.Write(format, arg);
		}

		public static void WriteLine(string s)
		{
			outWriter.WriteLine(s);
		}

		public static void WriteLine(string format, params object[] arg)
		{
			outWriter.WriteLine(format, arg);
		}

		public static void WriteLine()
		{
			outWriter.WriteLine();
		}
	}
}
