/*

 Copyright (c) 2006 Pavel Novak.

 The use and distribution terms for this software are contained in the file named License.txt, 
 which can be found in the root of the NetSim distribution. By using this software 
 in any fashion, you are agreeing to be bound by the terms of this license.
 
 You must not remove this notice from this software.

*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NetSim.Gui
{
	/// <summary>
	/// Summary description for ItemAppearanceForm.
	/// </summary>
	public class ItemAppearanceForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ColorDialog colorDialog;
		private System.Windows.Forms.Label colorLabel;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button chooseColorButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel colorPanel;
		private System.Windows.Forms.Button cancelButton;

		private DisplayElement item;

		public void SetItem(DisplayElement de)
		{
			this.item = de;
			this.colorPanel.BackColor = de.Color;
		}

		public ItemAppearanceForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.colorDialog = new System.Windows.Forms.ColorDialog();
			this.colorLabel = new System.Windows.Forms.Label();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.chooseColorButton = new System.Windows.Forms.Button();
			this.colorPanel = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// colorLabel
			// 
			this.colorLabel.Location = new System.Drawing.Point(16, 16);
			this.colorLabel.Name = "colorLabel";
			this.colorLabel.Size = new System.Drawing.Size(56, 16);
			this.colorLabel.TabIndex = 0;
			this.colorLabel.Text = "Color:";
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(40, 72);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 3;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(128, 72);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 4;
			this.cancelButton.Text = "Cancel";
			// 
			// chooseColorButton
			// 
			this.chooseColorButton.Location = new System.Drawing.Point(152, 16);
			this.chooseColorButton.Name = "chooseColorButton";
			this.chooseColorButton.Size = new System.Drawing.Size(75, 20);
			this.chooseColorButton.TabIndex = 2;
			this.chooseColorButton.Text = "Choose";
			this.chooseColorButton.Click += new System.EventHandler(this.chooseColorButton_Click);
			// 
			// colorPanel
			// 
			this.colorPanel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.colorPanel.Location = new System.Drawing.Point(56, 16);
			this.colorPanel.Name = "colorPanel";
			this.colorPanel.Size = new System.Drawing.Size(80, 20);
			this.colorPanel.TabIndex = 1;
			// 
			// ItemAppearanceForm
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cancelButton;
			this.ClientSize = new System.Drawing.Size(248, 117);
			this.ControlBox = false;
			this.Controls.Add(this.colorPanel);
			this.Controls.Add(this.chooseColorButton);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.colorLabel);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "ItemAppearanceForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Appearance";
			this.ResumeLayout(false);

		}
		#endregion

		private void chooseColorButton_Click(object sender, System.EventArgs e)
		{
			if (colorDialog.ShowDialog(this) == DialogResult.OK)
			{
				this.colorPanel.BackColor = colorDialog.Color;
			}
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			this.item.Color = this.colorPanel.BackColor;
			this.Close();
			MainForm.Instance.mainPanel.Invalidate();
		}
	}
}
