/*

 Copyright (c) 2006 Pavel Novak.

 The use and distribution terms for this software are contained in the file named License.txt, 
 which can be found in the root of the NetSim distribution. By using this software 
 in any fashion, you are agreeing to be bound by the terms of this license.
 
 You must not remove this notice from this software.

*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NetSim.Gui
{
	/// <summary>
	/// Summary description for NewVersionForm.
	/// </summary>
	public class NewVersionForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.LinkLabel netsimLinkLabel;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Button closeButton;
		private System.Windows.Forms.Label currentVersionLabel;
		private System.Windows.Forms.Label newVersionLabel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Version NewVersion
		{
			set { this.newVersionLabel.Text = value.ToString(); }
		}

		public Version CurrentVersion
		{
			set { this.currentVersionLabel.Text = value.ToString(); }
		}

		public NewVersionForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.currentVersionLabel = new System.Windows.Forms.Label();
			this.newVersionLabel = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.netsimLinkLabel = new System.Windows.Forms.LinkLabel();
			this.label7 = new System.Windows.Forms.Label();
			this.closeButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(256, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "New version is available.";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(88, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Current version:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(88, 16);
			this.label3.TabIndex = 3;
			this.label3.Text = "New version:";
			// 
			// currentVersionLabel
			// 
			this.currentVersionLabel.Location = new System.Drawing.Point(96, 48);
			this.currentVersionLabel.Name = "currentVersionLabel";
			this.currentVersionLabel.Size = new System.Drawing.Size(100, 16);
			this.currentVersionLabel.TabIndex = 2;
			this.currentVersionLabel.Text = "---";
			// 
			// newVersionLabel
			// 
			this.newVersionLabel.Location = new System.Drawing.Point(96, 64);
			this.newVersionLabel.Name = "newVersionLabel";
			this.newVersionLabel.Size = new System.Drawing.Size(100, 16);
			this.newVersionLabel.TabIndex = 4;
			this.newVersionLabel.Text = "---";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 88);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(192, 16);
			this.label6.TabIndex = 5;
			this.label6.Text = "Please visit";
			// 
			// netsimLinkLabel
			// 
			this.netsimLinkLabel.Location = new System.Drawing.Point(8, 104);
			this.netsimLinkLabel.Name = "netsimLinkLabel";
			this.netsimLinkLabel.Size = new System.Drawing.Size(264, 16);
			this.netsimLinkLabel.TabIndex = 6;
			this.netsimLinkLabel.TabStop = true;
			this.netsimLinkLabel.Text = "http://pavelnovak.eu/en/development/netsim/";
			this.netsimLinkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.netsimLinkLabel_LinkClicked);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 128);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(264, 32);
			this.label7.TabIndex = 7;
			this.label7.Text = "to download new version. Be sure to uninstall the old version first.";
			// 
			// closeButton
			// 
			this.closeButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.closeButton.Location = new System.Drawing.Point(104, 168);
			this.closeButton.Name = "closeButton";
			this.closeButton.TabIndex = 8;
			this.closeButton.Text = "Close";
			this.closeButton.Click += new System.EventHandler(this.closeButton_Click);
			// 
			// NewVersionForm
			// 
			this.AcceptButton = this.netsimLinkLabel;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.closeButton;
			this.ClientSize = new System.Drawing.Size(280, 197);
			this.ControlBox = false;
			this.Controls.Add(this.closeButton);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.netsimLinkLabel);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.currentVersionLabel);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.newVersionLabel);
			this.Name = "NewVersionForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "New Version";
			this.ResumeLayout(false);

		}
		#endregion

		private void closeButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void netsimLinkLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			// start the web browser
			try
			{
				System.Diagnostics.Process.Start(netsimLinkLabel.Text);
				this.Close();
			}
			catch (System.ComponentModel.Win32Exception noBrowser)
			{
				if (noBrowser.ErrorCode == -2147467259)
					MessageBox.Show(noBrowser.Message);
			}
			catch (System.Exception other)
			{
				MessageBox.Show(other.Message);
			}
		}
	}
}
