#ifndef _NETSIMSPECIFIC_H_
#define _NETSIMSPECIFIC_H_

#include "lspdef.h"

//--------------------------------------------------------------------------------------
// table of NetSim LSPWrapper WSP functions entry point
//
typedef
SOCKET
(WSPAPI * LPNETSIMWSPACCEPT)(
    SOCKET s,
    struct sockaddr FAR * addr,
    LPINT addrlen,
    LPCONDITIONPROC lpfnCondition,
    DWORD_PTR dwCallbackData,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
INT
(WSPAPI * LPNETSIMWSPADDRESSTOSTRING)(
    LPSOCKADDR lpsaAddress,
    DWORD dwAddressLength,
    LPWSAPROTOCOL_INFOW lpProtocolInfo,
    LPWSTR lpszAddressString,
    LPDWORD lpdwAddressStringLength,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPASYNCSELECT)(
    SOCKET s,
    HWND hWnd,
    unsigned int wMsg,
    long lEvent,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPBIND)(
    SOCKET s,
    const struct sockaddr FAR * name,
    int namelen,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPCANCELBLOCKINGCALL)(
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPCLEANUP)(
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPCLOSESOCKET)(
    SOCKET s,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPCONNECT)(
    SOCKET s,
    const struct sockaddr FAR * name,
    int namelen,
    LPWSABUF lpCallerData,
    LPWSABUF lpCalleeData,
    LPQOS lpSQOS,
    LPQOS lpGQOS,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPDUPLICATESOCKET)(
    SOCKET s,
    DWORD dwProcessId,
    LPWSAPROTOCOL_INFOW lpProtocolInfo,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPENUMNETWORKEVENTS)(
    SOCKET s,
    WSAEVENT hEventObject,
    LPWSANETWORKEVENTS lpNetworkEvents,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPEVENTSELECT)(
    SOCKET s,
    WSAEVENT hEventObject,
    long lNetworkEvents,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
BOOL
(WSPAPI * LPNETSIMWSPGETOVERLAPPEDRESULT)(
    SOCKET s,
    LPWSAOVERLAPPED lpOverlapped,
    LPDWORD lpcbTransfer,
    BOOL fWait,
    LPDWORD lpdwFlags,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPGETPEERNAME)(
    SOCKET s,
    struct sockaddr FAR * name,
    LPINT namelen,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPGETSOCKNAME)(
    SOCKET s,
    struct sockaddr FAR * name,
    LPINT namelen,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPGETSOCKOPT)(
    SOCKET s,
    int level,
    int optname,
    char FAR * optval,
    LPINT optlen,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
BOOL
(WSPAPI * LPNETSIMWSPGETQOSBYNAME)(
    SOCKET s,
    LPWSABUF lpQOSName,
    LPQOS lpQOS,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPIOCTL)(
    SOCKET s,
    DWORD dwIoControlCode,
    LPVOID lpvInBuffer,
    DWORD cbInBuffer,
    LPVOID lpvOutBuffer,
    DWORD cbOutBuffer,
    LPDWORD lpcbBytesReturned,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    LPWSATHREADID lpThreadId,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
SOCKET
(WSPAPI * LPNETSIMWSPJOINLEAF)(
    SOCKET s,
    const struct sockaddr FAR * name,
    int namelen,
    LPWSABUF lpCallerData,
    LPWSABUF lpCalleeData,
    LPQOS lpSQOS,
    LPQOS lpGQOS,
    DWORD dwFlags,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPLISTEN)(
    SOCKET s,
    int backlog,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPRECV)(
    SOCKET s,
    LPWSABUF lpBuffers,
    DWORD dwBufferCount,
    LPDWORD lpNumberOfBytesRecvd,
    LPDWORD lpFlags,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    LPWSATHREADID lpThreadId,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPRECVDISCONNECT)(
    SOCKET s,
    LPWSABUF lpInboundDisconnectData,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPRECVFROM)(
    SOCKET s,
    LPWSABUF lpBuffers,
    DWORD dwBufferCount,
    LPDWORD lpNumberOfBytesRecvd,
    LPDWORD lpFlags,
    struct sockaddr FAR * lpFrom,
    LPINT lpFromlen,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    LPWSATHREADID lpThreadId,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSELECT)(
    int nfds,
    fd_set FAR * readfds,
    fd_set FAR * writefds,
    fd_set FAR * exceptfds,
    const struct timeval FAR * timeout,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSEND)(
    SOCKET s,
    LPWSABUF lpBuffers,
    DWORD dwBufferCount,
    LPDWORD lpNumberOfBytesSent,
    DWORD dwFlags,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    LPWSATHREADID lpThreadId,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSENDDISCONNECT)(
    SOCKET s,
    LPWSABUF lpOutboundDisconnectData,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSENDTO)(
    SOCKET s,
    LPWSABUF lpBuffers,
    DWORD dwBufferCount,
    LPDWORD lpNumberOfBytesSent,
    DWORD dwFlags,
    const struct sockaddr FAR * lpTo,
    int iTolen,
    LPWSAOVERLAPPED lpOverlapped,
    LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine,
    LPWSATHREADID lpThreadId,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSETSOCKOPT)(
    SOCKET s,
    int level,
    int optname,
    const char FAR * optval,
    int optlen,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
int
(WSPAPI * LPNETSIMWSPSHUTDOWN)(
    SOCKET s,
    int how,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
SOCKET
(WSPAPI * LPNETSIMWSPSOCKET)(
    int af,
    int type,
    int protocol,
    LPWSAPROTOCOL_INFOW lpProtocolInfo,
    GROUP g,
    DWORD dwFlags,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

typedef
INT
(WSPAPI * LPNETSIMWSPSTRINGTOADDRESS)(
    LPWSTR AddressString,
    INT AddressFamily,
    LPWSAPROTOCOL_INFOW lpProtocolInfo,
    LPSOCKADDR lpAddress,
    LPINT lpAddressLength,
    LPINT lpErrno,
	LPREDIRECTION lpRedirection
    );

/*
 * A service provider proc table. This structure is returned by value
 * from the service provider's WSPStartup() entrypoint.
 */

typedef struct _NETSIMWSPPROC_TABLE {

    LPNETSIMWSPACCEPT              lpWSPAccept;
    LPNETSIMWSPADDRESSTOSTRING     lpWSPAddressToString;
    LPNETSIMWSPASYNCSELECT         lpWSPAsyncSelect;
    LPNETSIMWSPBIND                lpWSPBind;
    LPNETSIMWSPCANCELBLOCKINGCALL  lpWSPCancelBlockingCall;
    LPNETSIMWSPCLEANUP             lpWSPCleanup;
    LPNETSIMWSPCLOSESOCKET         lpWSPCloseSocket;
    LPNETSIMWSPCONNECT             lpWSPConnect;
    LPNETSIMWSPDUPLICATESOCKET     lpWSPDuplicateSocket;
    LPNETSIMWSPENUMNETWORKEVENTS   lpWSPEnumNetworkEvents;
    LPNETSIMWSPEVENTSELECT         lpWSPEventSelect;
    LPNETSIMWSPGETOVERLAPPEDRESULT lpWSPGetOverlappedResult;
    LPNETSIMWSPGETPEERNAME         lpWSPGetPeerName;
    LPNETSIMWSPGETSOCKNAME         lpWSPGetSockName;
    LPNETSIMWSPGETSOCKOPT          lpWSPGetSockOpt;
    LPNETSIMWSPGETQOSBYNAME        lpWSPGetQOSByName;
    LPNETSIMWSPIOCTL               lpWSPIoctl;
    LPNETSIMWSPJOINLEAF            lpWSPJoinLeaf;
    LPNETSIMWSPLISTEN              lpWSPListen;
    LPNETSIMWSPRECV                lpWSPRecv;
    LPNETSIMWSPRECVDISCONNECT      lpWSPRecvDisconnect;
    LPNETSIMWSPRECVFROM            lpWSPRecvFrom;
    LPNETSIMWSPSELECT              lpWSPSelect;
    LPNETSIMWSPSEND                lpWSPSend;
    LPNETSIMWSPSENDDISCONNECT      lpWSPSendDisconnect;
    LPNETSIMWSPSENDTO              lpWSPSendTo;
    LPNETSIMWSPSETSOCKOPT          lpWSPSetSockOpt;
    LPNETSIMWSPSHUTDOWN            lpWSPShutdown;
    LPNETSIMWSPSOCKET              lpWSPSocket;
    LPNETSIMWSPSTRINGTOADDRESS     lpWSPStringToAddress;

} NETSIMWSPPROC_TABLE, FAR * LPNETSIMWSPPROC_TABLE;

//---------------------------------------------------------------------------------------------------

BOOL NetSimRedirectCurrentCall(LPREDIRECTION lpRedirection);

// Typedefs for CRT initialization functions
typedef void (__stdcall *pfnEnsureInit)(void);
typedef void (__stdcall *pfnForceTerm)(void);

// Typedefs for calling wrapper functions
typedef int (__stdcall *pfnInitProcTable)(LPNETSIMWSPPROC_TABLE, LPWSPUPCALLTABLE);
typedef int (__stdcall *pfnNestingCount)(int);
typedef UINT (__stdcall *pfnGetThreadStartAddress)(int, int);

extern NETSIMWSPPROC_TABLE gWrapperProcTable;
extern long gNestingCounter;

void InitSharedData();
void DestroySharedData();

// Functions called by Redirections Manager
int AddRedirection(unsigned int pid, char * computer, unsigned short port);
int RemoveRedirection(unsigned int pid);
int BlockRedirections();
int ResumeRedirections();
int GetRedirection(int index, int * pid, char * computer, int computerSize, unsigned short * port, char * nodeName, int nodeNameSize);

int NetSimStartup();
int NetSimCleanup();

#endif