/*

 Copyright (c) 2006 Pavel Novak.

 The use and distribution terms for this software are contained in the file named License.txt, 
 which can be found in the root of the NetSim distribution. By using this software 
 in any fashion, you are agreeing to be bound by the terms of this license.
 
 You must not remove this notice from this software.

*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Text;
using System.Threading;
using Microsoft.Win32; // for registry access
using System.Reflection;

namespace NetSim
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.RedirectionsListBox = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.RemoveButton = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.WorkingDirTextBox = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.ExecuteTextBox = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.ArgsTextBox = new System.Windows.Forms.TextBox();
			this.BrowseButton = new System.Windows.Forms.Button();
			this.NodeNameTextBox = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.PortTextBox = new System.Windows.Forms.TextBox();
			this.PIDTextBox = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.StartButton = new System.Windows.Forms.Button();
			this.IPTextBox = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.NoteButton = new System.Windows.Forms.Button();
			this.label11 = new System.Windows.Forms.Label();
			this.BrowseDirButton = new System.Windows.Forms.Button();
			this.RefreshButton = new System.Windows.Forms.Button();
			this.CloseButton = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
			this.RemoveTerminatedCheckBox = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// RedirectionsListBox
			// 
			this.RedirectionsListBox.Location = new System.Drawing.Point(8, 32);
			this.RedirectionsListBox.Name = "RedirectionsListBox";
			this.RedirectionsListBox.ScrollAlwaysVisible = true;
			this.RedirectionsListBox.Size = new System.Drawing.Size(312, 121);
			this.RedirectionsListBox.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(232, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Processes which connections are redirected";
			// 
			// RemoveButton
			// 
			this.RemoveButton.Location = new System.Drawing.Point(328, 64);
			this.RemoveButton.Name = "RemoveButton";
			this.RemoveButton.TabIndex = 3;
			this.RemoveButton.Text = "Remove";
			this.RemoveButton.Click += new System.EventHandler(this.RemoveButton_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.WorkingDirTextBox);
			this.groupBox1.Controls.Add(this.label12);
			this.groupBox1.Controls.Add(this.label10);
			this.groupBox1.Controls.Add(this.ExecuteTextBox);
			this.groupBox1.Controls.Add(this.label9);
			this.groupBox1.Controls.Add(this.ArgsTextBox);
			this.groupBox1.Controls.Add(this.BrowseButton);
			this.groupBox1.Controls.Add(this.NodeNameTextBox);
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.label7);
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.PortTextBox);
			this.groupBox1.Controls.Add(this.PIDTextBox);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.StartButton);
			this.groupBox1.Controls.Add(this.IPTextBox);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.NoteButton);
			this.groupBox1.Controls.Add(this.label11);
			this.groupBox1.Controls.Add(this.BrowseDirButton);
			this.groupBox1.Location = new System.Drawing.Point(8, 184);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(392, 296);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Start new redirection";
			// 
			// WorkingDirTextBox
			// 
			this.WorkingDirTextBox.Location = new System.Drawing.Point(104, 88);
			this.WorkingDirTextBox.Name = "WorkingDirTextBox";
			this.WorkingDirTextBox.Size = new System.Drawing.Size(208, 20);
			this.WorkingDirTextBox.TabIndex = 7;
			this.WorkingDirTextBox.Text = "";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(8, 88);
			this.label12.Name = "label12";
			this.label12.TabIndex = 6;
			this.label12.Text = "Working directory:";
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label10.ForeColor = System.Drawing.Color.Navy;
			this.label10.Location = new System.Drawing.Point(8, 16);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(168, 23);
			this.label10.TabIndex = 0;
			this.label10.Text = "Either run new process:";
			// 
			// ExecuteTextBox
			// 
			this.ExecuteTextBox.Location = new System.Drawing.Point(104, 40);
			this.ExecuteTextBox.Name = "ExecuteTextBox";
			this.ExecuteTextBox.Size = new System.Drawing.Size(208, 20);
			this.ExecuteTextBox.TabIndex = 2;
			this.ExecuteTextBox.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 56);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(80, 32);
			this.label9.TabIndex = 4;
			this.label9.Text = "Command line arguments:";
			// 
			// ArgsTextBox
			// 
			this.ArgsTextBox.Location = new System.Drawing.Point(104, 64);
			this.ArgsTextBox.Name = "ArgsTextBox";
			this.ArgsTextBox.Size = new System.Drawing.Size(280, 20);
			this.ArgsTextBox.TabIndex = 5;
			this.ArgsTextBox.Text = "";
			// 
			// BrowseButton
			// 
			this.BrowseButton.Location = new System.Drawing.Point(320, 40);
			this.BrowseButton.Name = "BrowseButton";
			this.BrowseButton.Size = new System.Drawing.Size(64, 20);
			this.BrowseButton.TabIndex = 3;
			this.BrowseButton.Text = "Browse";
			this.BrowseButton.Click += new System.EventHandler(this.BrowseButton_Click);
			// 
			// NodeNameTextBox
			// 
			this.NodeNameTextBox.Location = new System.Drawing.Point(72, 232);
			this.NodeNameTextBox.Name = "NodeNameTextBox";
			this.NodeNameTextBox.Size = new System.Drawing.Size(312, 20);
			this.NodeNameTextBox.TabIndex = 19;
			this.NodeNameTextBox.Text = "";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 232);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(72, 16);
			this.label8.TabIndex = 18;
			this.label8.Text = "Node name:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(304, 208);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(32, 16);
			this.label7.TabIndex = 16;
			this.label7.Text = "Port:";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 208);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(64, 16);
			this.label6.TabIndex = 14;
			this.label6.Text = "IP or name:";
			// 
			// PortTextBox
			// 
			this.PortTextBox.Enabled = false;
			this.PortTextBox.Location = new System.Drawing.Point(336, 208);
			this.PortTextBox.Name = "PortTextBox";
			this.PortTextBox.Size = new System.Drawing.Size(48, 20);
			this.PortTextBox.TabIndex = 17;
			this.PortTextBox.Text = "9001";
			// 
			// PIDTextBox
			// 
			this.PIDTextBox.Location = new System.Drawing.Point(144, 152);
			this.PIDTextBox.Name = "PIDTextBox";
			this.PIDTextBox.Size = new System.Drawing.Size(72, 20);
			this.PIDTextBox.TabIndex = 11;
			this.PIDTextBox.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 152);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(144, 23);
			this.label5.TabIndex = 10;
			this.label5.Text = "Attach to process (PID):";
			// 
			// StartButton
			// 
			this.StartButton.Location = new System.Drawing.Point(152, 264);
			this.StartButton.Name = "StartButton";
			this.StartButton.TabIndex = 20;
			this.StartButton.Text = "Start";
			this.StartButton.Click += new System.EventHandler(this.StartButton_Click);
			// 
			// IPTextBox
			// 
			this.IPTextBox.Enabled = false;
			this.IPTextBox.Location = new System.Drawing.Point(72, 208);
			this.IPTextBox.Name = "IPTextBox";
			this.IPTextBox.Size = new System.Drawing.Size(224, 20);
			this.IPTextBox.TabIndex = 15;
			this.IPTextBox.Text = "localhost";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 192);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(368, 16);
			this.label3.TabIndex = 13;
			this.label3.Text = "Redirect to machine (only local machine supported in this version):";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(88, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Execute (path):";
			// 
			// NoteButton
			// 
			this.NoteButton.Location = new System.Drawing.Point(224, 152);
			this.NoteButton.Name = "NoteButton";
			this.NoteButton.Size = new System.Drawing.Size(66, 20);
			this.NoteButton.TabIndex = 12;
			this.NoteButton.Text = "See note";
			this.NoteButton.Click += new System.EventHandler(this.NoteButton_Click);
			// 
			// label11
			// 
			this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label11.ForeColor = System.Drawing.Color.Navy;
			this.label11.Location = new System.Drawing.Point(8, 128);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(168, 23);
			this.label11.TabIndex = 9;
			this.label11.Text = "Or attach to an existing one:";
			// 
			// BrowseDirButton
			// 
			this.BrowseDirButton.Location = new System.Drawing.Point(320, 88);
			this.BrowseDirButton.Name = "BrowseDirButton";
			this.BrowseDirButton.Size = new System.Drawing.Size(64, 20);
			this.BrowseDirButton.TabIndex = 8;
			this.BrowseDirButton.Text = "Browse";
			this.BrowseDirButton.Click += new System.EventHandler(this.BrowseDirButton_Click);
			// 
			// RefreshButton
			// 
			this.RefreshButton.Location = new System.Drawing.Point(328, 32);
			this.RefreshButton.Name = "RefreshButton";
			this.RefreshButton.Size = new System.Drawing.Size(75, 24);
			this.RefreshButton.TabIndex = 2;
			this.RefreshButton.Text = "Refresh";
			this.RefreshButton.Click += new System.EventHandler(this.RefreshButton_Click);
			// 
			// CloseButton
			// 
			this.CloseButton.Location = new System.Drawing.Point(240, 488);
			this.CloseButton.Name = "CloseButton";
			this.CloseButton.Size = new System.Drawing.Size(160, 23);
			this.CloseButton.TabIndex = 6;
			this.CloseButton.Text = "Close Redirection Manager";
			this.CloseButton.Click += new System.EventHandler(this.CloseButton_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 488);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(224, 32);
			this.label4.TabIndex = 7;
			this.label4.Text = "All currently running redirections will continue even if the manager is not runni" +
				"ng.";
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = "Executables|*.exe|All files|*.*";
			this.openFileDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog_FileOk);
			// 
			// folderBrowserDialog
			// 
			this.folderBrowserDialog.ShowNewFolderButton = false;
			// 
			// RemoveTerminatedCheckBox
			// 
			this.RemoveTerminatedCheckBox.Checked = true;
			this.RemoveTerminatedCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
			this.RemoveTerminatedCheckBox.Location = new System.Drawing.Point(8, 152);
			this.RemoveTerminatedCheckBox.Name = "RemoveTerminatedCheckBox";
			this.RemoveTerminatedCheckBox.Size = new System.Drawing.Size(248, 24);
			this.RemoveTerminatedCheckBox.TabIndex = 4;
			this.RemoveTerminatedCheckBox.Text = "Automatically remove terminated processes";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 525);
			this.Controls.Add(this.RemoveTerminatedCheckBox);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.CloseButton);
			this.Controls.Add(this.RefreshButton);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.RemoveButton);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.RedirectionsListBox);
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.Text = "Packet Redirection Manager";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// we need to have current directory set to application Bin directory where nonifslsp.dll resides
			// otherwise PInvoke won't work. Look into the registry for install directory and set current dir
			// appropriately
			object[] product_attrs = Assembly.GetAssembly(typeof(NetSim.Core.Simulator)).GetCustomAttributes(typeof(AssemblyProductAttribute), false);
			object[] company_attrs = Assembly.GetAssembly(typeof(NetSim.Core.Simulator)).GetCustomAttributes(typeof(AssemblyCompanyAttribute), false);
			if (product_attrs.Length > 0 && company_attrs.Length > 0)
			{
				RegistryKey key = Registry.LocalMachine.OpenSubKey(
					String.Format("Software\\{0}\\{1}",	((AssemblyCompanyAttribute)company_attrs[0]).Company,
					((AssemblyProductAttribute)product_attrs[0]).Product)
					);

				if (key != null)
				{
					string install_dir = key.GetValue("InstallDir") as string;
					if (install_dir != null)
					{
						string new_cur_dir = install_dir + "Bin";
						if (System.IO.Directory.Exists(new_cur_dir))
							Environment.CurrentDirectory = new_cur_dir;
					}
				}
			}

			//WORKING:
			//Environment.CurrentDirectory = @"E:\PAVEL\skola\MFF\diplomka\src\NetSim\LSP\nonifslsp\WIN2000_DEBUG";

			try
			{
				// run the application
				Application.Run(new MainForm());
			}
			catch (DllNotFoundException)
			{
				MessageBox.Show(null, String.Format("Dll library {0} cannot be found. Application will close.", LSP.lspDll),
					"Error loading library", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Button NoteButton;
		private System.Windows.Forms.Button StartButton;
		private System.Windows.Forms.TextBox PIDTextBox;
		private System.Windows.Forms.TextBox IPTextBox;
		private System.Windows.Forms.TextBox PortTextBox;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button CloseButton;
		private System.Windows.Forms.Button BrowseButton;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.TextBox ExecuteTextBox;
		private System.Windows.Forms.Button RemoveButton;
		private System.Windows.Forms.Button RefreshButton;
		private System.Windows.Forms.TextBox NodeNameTextBox;
		private System.Windows.Forms.ListBox RedirectionsListBox;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox ArgsTextBox;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TextBox WorkingDirTextBox;
		private System.Windows.Forms.Button BrowseDirButton;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
		private System.Windows.Forms.Label label7;

		/// <summary>
		/// The thread periodically updating the list of redirected processes.
		/// </summary>
		private Thread refreshThread;
		/// <summary>
		/// Is set to <b>true</b> if the <see cref="refreshThread"/> should exit its execution.
		/// </summary>
		private bool refreshThreadStop = false;

		private int refreshThreadInterval = 1000;
		private System.Windows.Forms.CheckBox RemoveTerminatedCheckBox;
		private int refreshThreadWait = 5000;

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			refreshThread = new Thread(new ThreadStart(this.RefreshThread));
			refreshThread.Start();
		}

		private void RefreshThread()
		{
			try
			{
				while (!refreshThreadStop)
				{
					// simple algorithm: check if the list corresponds to processes being redirected, if not,
					// refresh completely
					int index = 1;
					bool okay = true;
					bool refresh = false;
					while (okay)
					{
						int pid = 0;
						StringBuilder computer = new StringBuilder(512);
						UInt16 port = 0;
						StringBuilder nodeName = new StringBuilder(512);
						okay = 0 == LSP.GetRedirection(index, ref pid, computer, computer.Capacity, ref port, nodeName, nodeName.Capacity);

						if (okay)
						{
							if (RedirectionsListBox.Items.Count < index) // index starts at one
							{
								refresh = true;
								break;
							}

							RedirectionsListEntry entry = (RedirectionsListEntry)RedirectionsListBox.Items[index-1];
							if (
								entry.Computer != computer.ToString()
								|| entry.Port != port
								|| entry.NodeName != nodeName.ToString()
								)
							{
								refresh = true;
								break;
							}

							if (entry.Running) // check if the process is still running
							{
								Process p = null;
								try { p = Process.GetProcessById(entry.ProcessID); }
								catch (Exception) {}

								if (p == null)
								{
									if (RemoveTerminatedCheckBox.Checked)
										LSP.RemoveRedirection(entry.ProcessID);

									refresh = true;
								}
							}
						}

						index++;
					}

					if (refresh)
						RefreshRedirectionsList();

					Thread.Sleep(refreshThreadInterval);
				}
			}
			catch (DllNotFoundException)
			{
				MessageBox.Show(this, String.Format("Dll library {0} cannot be found. Application will close.", LSP.lspDll),
					"Error loading library", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.Close();
			}
		}

		private void NoteButton_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(this, "If you specify the process that is currently running, note that only new connections will be redirected. If the process have some sockets open, data will not be redirected until they are closed and reopen again.", "Note");
		}

		private void StartButton_Click(object sender, System.EventArgs e)
		{
			// trim spaces
			ExecuteTextBox.Text = ExecuteTextBox.Text.Trim();
			PIDTextBox.Text = PIDTextBox.Text.Trim();
			IPTextBox.Text = IPTextBox.Text.Trim();
			PortTextBox.Text = PortTextBox.Text.Trim();
			
			StringBuilder errors = new StringBuilder();
			// check values
			if (ExecuteTextBox.Text != "" && PIDTextBox.Text != "")
				errors.Append("Either a file to execute or the PID to attach can be specified, but not both.\n");
			if (ExecuteTextBox.Text == "" && PIDTextBox.Text == "")
				errors.Append("Neither a file to execute nor the PID to attach is specified.\n");
			if (IPTextBox.Text == "")
				errors.Append("Machine name (IP address) where the simulator is running not specified. (Use 'localhost' if it is running at this computer.)\n");
			if (PortTextBox.Text == "")
				errors.Append("Port number where the simulator is listening for connections is not specified. (Default is 9001)\n");
			if (NodeNameTextBox.Text == "")
				errors.Append("The node in the virtual network where the program should be virtually running not specified.\n");

			UInt16 port = 0;
			try { port = UInt16.Parse(PortTextBox.Text); }
			catch (Exception) {}
			if (port == 0)
				errors.Append("The port value is invalid.\n");

			int pid = 0;
			if (ExecuteTextBox.Text == "")
			{
				try { pid = int.Parse(PIDTextBox.Text); }
				catch (Exception) {}
				if (pid == 0)
					errors.Append("Process ID value is invalid.\n");
			}

			if (errors.Length > 0)
			{
				MessageBox.Show(this, errors.ToString(), "Error");
				return;
			}

			// start new process if required
			Process proc = null;
			if (ExecuteTextBox.Text != "")
			{
				try
				{
					// block redirections while the process is starting - we need to know it's PID
					LSP.BlockRedirections();

					proc = StartProcess(ExecuteTextBox.Text, ArgsTextBox.Text, WorkingDirTextBox.Text);
					pid = proc.Id;
				}
				catch (DllNotFoundException)
				{
					MessageBox.Show(this, String.Format("Dll library {0} cannot be found.", LSP.lspDll),
						"Error loading library", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				catch (Exception exc)
				{
					LSP.ResumeRedirections();

					MessageBox.Show(String.Format("Unable to start {0}: {1}", ExecuteTextBox.Text, exc.Message));
					if (proc != null)
						proc.Kill();

					return;
				}
			}

			int result = LSP.AddRedirection(pid, IPTextBox.Text, port, NodeNameTextBox.Text);

			// resume redirections if they have been stopped
			if (proc != null)
				LSP.ResumeRedirections();

			if (result == -2)
				MessageBox.Show(this, "Unable to add the redirection (Shared memory for redirection entries cannot be created).");
			if (result == -1)
				MessageBox.Show(this, "Unable to add the redirection (maximum number of redirections exceeded).");

			RefreshRedirectionsList();
		}

		private Process StartProcess(string path, string args, string workingDir)
		{
			Process p = new Process();
			ProcessStartInfo si = new ProcessStartInfo(path, args);
			if (workingDir != "")
				si.WorkingDirectory = workingDir;


			p.StartInfo = si;
			p.Start();

			return p;
		}

		private void CloseButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void BrowseButton_Click(object sender, System.EventArgs e)
		{
			openFileDialog.ShowDialog(this);
		}

		private void openFileDialog_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.ExecuteTextBox.Text = openFileDialog.FileName;
		}

		private void RefreshRedirectionsList()
		{
			RedirectionsListBox.Items.Clear();
			int index = 1;
			bool okay = true;
			while (okay)
			{
				int pid = 0;
				StringBuilder computer = new StringBuilder(512);
				UInt16 port = 0;
				StringBuilder nodeName = new StringBuilder(512);
				okay = 0 == LSP.GetRedirection(index, ref pid, computer, computer.Capacity, ref port, nodeName, nodeName.Capacity);

				if (okay)
				{
					RedirectionsListEntry entry = new RedirectionsListEntry(pid);
					entry.Computer = computer.ToString();
					entry.Port = port;
					entry.NodeName = nodeName.ToString();
					RedirectionsListBox.Items.Add(entry);
				}

				index++;
			}
		}

		private void RefreshButton_Click(object sender, System.EventArgs e)
		{
			RefreshRedirectionsList();
		}

		private void RemoveButton_Click(object sender, System.EventArgs e)
		{
			int index = RedirectionsListBox.SelectedIndex;
			if (index < 0)
			{
				if (RedirectionsListBox.Items.Count > 0)
					MessageBox.Show(this, "Please select a process from the list.", "Error");
				else
					MessageBox.Show(this, "There is no redirection to remove. (Try Refresh button.)", "Error");

				return;
			}

			RedirectionsListEntry entry = (RedirectionsListEntry)RedirectionsListBox.Items[index];
			LSP.RemoveRedirection(entry.ProcessID);
			RedirectionsListBox.Items.RemoveAt(index);
		}

		private void BrowseDirButton_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog.ShowDialog(this);
			WorkingDirTextBox.Text = folderBrowserDialog.SelectedPath;
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			refreshThreadStop = true;
			
			if (!refreshThread.Join(refreshThreadWait))
				refreshThread.Abort();
		}

	}

	public class RedirectionsListEntry
	{
		public int ProcessID;
		public string Description;
		public string Computer;
		public UInt16 Port;
		public string NodeName;
		public bool Running;

		public RedirectionsListEntry(int pid)
		{
			this.ProcessID = pid;
			Process process = null;
			try {	process = Process.GetProcessById(pid); }
			catch (ArgumentException) { }

			if (process != null)
			{
				try
				{
					Description = process.MainWindowTitle; 
					Running = true;
				}
				catch (InvalidOperationException)
				{
					process = null;
				}
			}

			if (process == null)
			{
				Description = "<not running>";
				Running = false;
			}

		}

		public override string ToString()
		{
			return String.Format("[{4}] {0} -> {1}:{2}[{3}]", Description, Computer, Port, NodeName, ProcessID);
		}

	}

	/// <summary>
	/// For accessing kernel LoadLibrary and FreeLibrary functions
	/// </summary>
	public class Kernel32
	{
		[DllImport("kernel32")]
		public extern static IntPtr LoadLibrary(string lpLibFileName);

		[DllImport("kernel32")]
		public extern static Int32 FreeLibrary(IntPtr hModule);
	}

	/// <summary>
	/// For accessing LSP functions.
	/// </summary>
	public class LSP
	{
		internal const string lspDll = @"nonifslsp.dll";

		[DllImport(lspDll)]
		public static extern int GetRedirection(int index, ref int pid, StringBuilder computer, int computerSize, ref UInt16 port, StringBuilder nodeName, int nodeNameSize);

		[DllImport(lspDll)]
		public static extern Int32 AddRedirection(int processID, string computer, UInt16 port, string nodeName);

		[DllImport(lspDll)]
		public static extern Int32 RemoveRedirection(int processID);

		[DllImport(lspDll)]
		public static extern Int32 BlockRedirections();

		[DllImport(lspDll)]
		public static extern Int32 ResumeRedirections();
	}


}
