/*

 Copyright (c) 2006 Pavel Novak.

 The use and distribution terms for this software are contained in the file named License.txt, 
 which can be found in the root of the NetSim distribution. By using this software 
 in any fashion, you are agreeing to be bound by the terms of this license.
 
 You must not remove this notice from this software.

*/

using System;
using NetSim.Core;

namespace NetSim.Library.Modules
{
	/// <summary>
	/// This module takes all received packets and resends them with no change to other links.
	/// </summary>
	public class Repeater : Module
	{
		public override void ReceivePacket(ref PacketInfo pInfo)
		{
			// immediately send down to other adapters
			pInfo.ExcludeAdapter = pInfo.UseAdapter;
			pInfo.UseAdapter = null;

			SendNewPacket(pInfo);

			// packet is resent, do not continue with processing
			pInfo = null;
		}
	}
}
