using System;
using NetSim.Core;
using System.Net.Sockets;
using System.Threading;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;

public class RO : MarshalByRefObject
{
	public int i;

	public void Method(ObjRef RCRef)
	{
		RC rc = (RC)RemotingServices.Unmarshal(RCRef);
		rc.i = 1;
	}

	public override object InitializeLifetimeService()
	{
		return null;
	}
}

public class RC : MarshalByRefObject
{
	public int i = 0;

	public override object InitializeLifetimeService()
	{
		return null;
	}

}

public class Tester
{

	static public void A()
	{
		BinaryServerFormatterSinkProvider serverProv = new BinaryServerFormatterSinkProvider();
		serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
		System.Collections.Specialized.ListDictionary channelProperties = new System.Collections.Specialized.ListDictionary();
		channelProperties.Add("name", "A");
		channelProperties.Add("section", "NetSimServer");
		IChannel remoteSocketsShmChannel = new PHP.Core.ShmChannel(channelProperties, new BinaryClientFormatterSinkProvider(), serverProv);
		ChannelServices.RegisterChannel(remoteSocketsShmChannel);

		RemotingConfiguration.RegisterWellKnownServiceType(typeof(RO), "RO", WellKnownObjectMode.Singleton);
		new RO();

		Console.ReadLine();
	}

	static public void B()
	{
		BinaryServerFormatterSinkProvider serverProv = new BinaryServerFormatterSinkProvider();
		serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
		System.Collections.Specialized.ListDictionary channelProperties = new System.Collections.Specialized.ListDictionary();
		channelProperties.Add("name", "B");
		IChannel remoteSocketsShmChannel = new PHP.Core.ShmChannel(channelProperties, new BinaryClientFormatterSinkProvider(), serverProv);
		ChannelServices.RegisterChannel(remoteSocketsShmChannel);

		RC rc = new RC();
		ObjRef rf = RemotingServices.Marshal(rc);

		RO ro = (RO)Activator.GetObject(typeof(RO), "shm://NetSimServer/RO");
		ro.Method(rf);

		Console.WriteLine(rc.i);
		Console.ReadLine();
	}

	static public void TestRemote()
	{
		BinaryServerFormatterSinkProvider serverProv = new BinaryServerFormatterSinkProvider();
		serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
		System.Collections.Specialized.ListDictionary channelProperties = new System.Collections.Specialized.ListDictionary();
		channelProperties.Add("name", "TestRemote");
		IChannel remoteSocketsShmChannel = new PHP.Core.ShmChannel(channelProperties, new BinaryClientFormatterSinkProvider(), serverProv);
		ChannelServices.RegisterChannel(remoteSocketsShmChannel);

		SocketCallbackObject sc = new SocketCallbackObject();
		ObjRef rf = RemotingServices.Marshal(sc);

		RemoteSocketsManager rsm = (RemoteSocketsManager)Activator.GetObject(typeof(RemoteSocketsManager), "shm://NetSimServer/" + Simulator.RemoteSocketsManagerObjectName);
		rsm.Test(rf);

		Console.WriteLine("Test finished");
		Console.ReadLine();
	}

	/// <summary>
	/// The main entry point for the application.
	/// </summary>
	[STAThread]
	static void Main(string[] args)
	{
		if (args.Length > 0 && args[0] == "A")
			A();
		else if (args.Length > 0 && args[0] == "B")
			B();
		else if (args.Length > 0 && args[0] == "TestRemote")
			TestRemote();
		else
		TestSimulator(args);
		//TestSocket(args);
	}


	static void TestSimulator(string[] args)
	{
		string config_file = null;
		if (args.Length == 0)
		{
//			Console.WriteLine("Expecting configuration file as the first argument.");
//			Console.ReadLine();
//			return;
			config_file = @"E:\PAVEL\skola\MFF\diplomka\src\NetSim\Core\Configuration\NetSimConfig.xml";
		}

		if (config_file == null)
			config_file = args[0];

		try
		{
			Console.Write("Configuring simulator... ");
			Simulator.GetInstance().Configure(config_file);
			Console.WriteLine("Done.");

			Console.Write("Starting simulator... ");
			Simulator.GetInstance().Start();
			Console.WriteLine("Done.");

			for (int i = 0; i < 10; i++)
			{
				Console.WriteLine("Press Enter for suspending nodes B and C..");
				Console.ReadLine();
			
				Console.Write("Suspending node B... ");
				Simulator.GetInstance().GetNode("B").Enabled = false;
				Console.WriteLine("Done.");
				Console.Write("Suspending node C... ");
				Simulator.GetInstance().GetNode("C").Enabled = false;
				Console.WriteLine("Done.");

				Console.WriteLine("Pause - press Enter for resuming nodes.");
				Console.ReadLine();

				Console.Write("Resuming node B... ");
				Simulator.GetInstance().GetNode("B").Enabled = true;
				Console.WriteLine("Done.");
				Console.Write("Resuming node C... ");
				Simulator.GetInstance().GetNode("C").Enabled = true;
				Console.WriteLine("Done.");
			}
			Console.WriteLine();
			Console.WriteLine("Press Enter to exit...");
			Console.ReadLine();

			Console.Write("Shutting down simulator... ");
			Simulator.GetInstance().Stop();
			Console.WriteLine("Done.");
			//Console.ReadLine();
		}
		catch (Exception e)
		{
			Console.WriteLine(e.Message);
			Console.WriteLine(e.ToString());
			
			Console.ReadLine();
		}
	}

	static void TestSocket(string[] args)
	{
		Socket s = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
		s.Bind(new System.Net.IPEndPoint(System.Net.IPAddress.Any, 2222));
		s.Listen(20);
		Socket s2 = s.Accept();

		byte[] buffer = new byte[10000];
		int i = s2.Receive(buffer);
		//s.Connect(new System.Net.IPEndPoint(System.Net.IPAddress.Parse("192.168.1.1"), 1234));

		s.Close();
		s2.Close();

		//Socket s2 = s.Accept();
		Console.WriteLine(String.Format("Connection accepted, {0} bytes received.", i));
		Console.ReadLine();
			
	}
}
