// $Id: AnsiEscapeSequences.java,v 1.1 2001/06/01 06:24:44 pcharles Exp $

/// <summary>************************************************************************
/// Copyright (C) 2001, Patrick Charles and Jonas Lehmann                   *
/// Distributed under the Mozilla Public License                            *
/// http://www.mozilla.org/NPL/MPL-1.1.txt                                *
/// *************************************************************************
/// </summary>
namespace Tamir.IPLib.Packets.Util
{
	using System;
	
	/// <summary> String constants for color console output.
	/// <p>
	/// This file contains control sequences to print color text on a text 
	/// console capable of interpreting and displaying control sequences.
	/// <p>
	/// A capable console would be 
	/// unix bash, os/2 shell, or command.com w/ ansi.sys loaded
	/// *
	/// </summary>
	/// <author>  Chris Cheetham
	/// 
	/// </author>
	public struct AnsiEscapeSequences_Fields{
		public readonly static System.String ESCAPE_BEGIN;
		public readonly static System.String ESCAPE_END = "m";
		public readonly static System.String RESET;
		public readonly static System.String BOLD;
		public readonly static System.String UNDERLINE;
		public readonly static System.String INVERSE;
		public readonly static System.String BLACK;
		public readonly static System.String BLUE;
		public readonly static System.String GREEN;
		public readonly static System.String CYAN;
		public readonly static System.String RED;
		public readonly static System.String PURPLE;
		public readonly static System.String BROWN;
		public readonly static System.String LIGHT_GRAY;
		public readonly static System.String DARK_GRAY;
		public readonly static System.String LIGHT_BLUE;
		public readonly static System.String LIGHT_GREEN;
		public readonly static System.String LIGHT_CYAN;
		public readonly static System.String LIGHT_RED;
		public readonly static System.String LIGHT_PURPLE;
		public readonly static System.String YELLOW;
		public readonly static System.String WHITE;
		public readonly static System.String RED_BACKGROUND;
		public readonly static System.String GREEN_BACKGROUND;
		public readonly static System.String YELLOW_BACKGROUND;
		public readonly static System.String BLUE_BACKGROUND;
		public readonly static System.String PURPLE_BACKGROUND;
		public readonly static System.String CYAN_BACKGROUND;
		public readonly static System.String LIGHT_GRAY_BACKGROUND;
		static AnsiEscapeSequences_Fields()
		{
			ESCAPE_BEGIN = "" + (char) 27 + "[";
			RESET = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			BOLD = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;1" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			UNDERLINE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;4" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			INVERSE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;7" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			BLACK = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;30" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			BLUE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;34" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			GREEN = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;32" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			CYAN = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;36" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			RED = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;31" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			PURPLE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;35" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			BROWN = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;33" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_GRAY = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;37" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			DARK_GRAY = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;30" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_BLUE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;34" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_GREEN = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;32" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_CYAN = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;36" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_RED = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;31" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_PURPLE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;35" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			YELLOW = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;33" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			WHITE = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "1;37" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			RED_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;41" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			GREEN_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;42" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			YELLOW_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;43" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			BLUE_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;44" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			PURPLE_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;45" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			CYAN_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;46" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
			LIGHT_GRAY_BACKGROUND = Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_BEGIN + "0;47" + Tamir.IPLib.Packets.Util.AnsiEscapeSequences_Fields.ESCAPE_END;
		}
	}
	public interface AnsiEscapeSequences
		{
			//UPGRADE_NOTE: Members of interface 'AnsiEscapeSequences' were extracted into structure 'AnsiEscapeSequences_Fields'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1045"'
		}
}